/* KEY.C file
STM32-SDK 

뻷MDK-Lite  Version: 4.23
ʱ: 2012-02-28

ܣʵ	STM32-SDK ϵ LED ӿ

---------Ӳϵ:----------
LED -->  PA8  	(͵ƽ,;ߵƽ)
------------------------------------
 */

#include "LED.h"


/**************************ʵֺ********************************************
*ԭ:		void Initial_LED_GPIO(void)
*:		 LED ӦĶ˿Ϊ
*******************************************************************************/
void Initial_LED_GPIO(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  //ʹGPIOB ʱ,
  RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB |RCC_APB2Periph_AFIO, ENABLE);
  //PB0 Ϊ  ˢƵΪ2Mhz
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;	
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;       
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  //ӦõGPIOB 
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  	/*
	 PB5Ϊ ʹ
	*/
 	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4 | GPIO_Pin_5 ; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 
	//ӦáGPIOB
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	/*
	 PA15Ϊ ʹ
	*/
 	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15 ; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU; 
	//ӦáGPIOB
	GPIO_Init(GPIOA, &GPIO_InitStructure);


  //LED ˿ߵƽ, ص.
  GPIO_SetBits(GPIOB, GPIO_Pin_0);	 
}

/**************************ʵֺ********************************************
*ԭ:		void Initial_PWMLED(void)
*:		 PWM  ʹPB1PWMź.
*******************************************************************************/
void Initial_PWMLED(void)
{
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
	TIM_OCInitTypeDef  TIM_OCInitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;

	//ʹTIMER3 ʱź
	//PCLK12ƵΪTIM3ʱԴ36MHz
  	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE); 
  	//ʹ GPIOA ʱź
  	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE); 

  	// PA8 Ϊ ˢƵ50MHz
 	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_8;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;		   
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    //Ӧ
  	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* ʱ:
	1.öʱֵ 256	
	2.ʱӷƵϵTIM_CKD_DIV2
	3. ԤƵ2036M/2/20=900Khz  PWMƵ:900Khz/256 Լ3.5KHz
	4.ʱģʽ  ϼģʽ
	*/		 
  	TIM_TimeBaseStructure.TIM_Period = 200;       
  	TIM_TimeBaseStructure.TIM_Prescaler = 20;	   
  	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;	
  	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; 
	TIM_TimeBaseStructure.TIM_RepetitionCounter =0;
	//ӦõTIM3 
  	TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure);

  	/* PWMͨ 3 
	1. ΪPWMģʽ1  TIM3_CNT>TIM3_CCR3ʱΪͣΪ
	2.ʹPWM
	3. ռձ, Ϊ 20/256
	*/
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;	   
  	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_Low;// 
  	TIM_OCInitStructure.TIM_Pulse = 20;	
	//ӦõTim1 OC1
  	TIM_OC1Init(TIM1, &TIM_OCInitStructure);
	//ʹOC1 Զ
  	TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Enable);

	// ʹTIM1ؼĴARR
  	TIM_ARRPreloadConfig(TIM1, ENABLE);	
	//ʹTime1 жϡж		 
	//TIM_ITConfig(TIM1, TIM_IT_Update, ENABLE);
  	//ʱ1
  	TIM_Cmd(TIM1, ENABLE);   
	TIM_CtrlPWMOutputs(TIM1, ENABLE);               
}

//LED ȼ
static int LightLevel[40]={0,0,0,0,0,1,1,2,4,8,16,32,50,64,80,100,100,120,140,180,180,140,120,100,100,80,64,50,32,16,8,4,2,1,1,0,0,0,0,0};
u8 lightc=0;
/**************************ʵֺ********************************************
*ԭ:		void LED_Change(void)
*:		ıLEDȣ	LightLevel 
*******************************************************************************/
void LED_Change(void)
{
	TIM1->CCR1=LightLevel[lightc]; //ͨ1ıȽֵ
	if(++lightc==40)lightc=0;
}

/**************************ʵֺ********************************************
*ԭ:		void LED_Reverse(void)
*:		LED ȡ, ,ʱö˿ʹ֮ת״̬,
								ʱö˿ʹ֮ת״̬.
*******************************************************************************/
void LED_Reverse(void)
{
	if(GPIO_ReadOutputDataBit(GPIOA, GPIO_Pin_8))	
		GPIO_ResetBits(GPIOA, GPIO_Pin_8);
		else
		GPIO_SetBits(GPIOA, GPIO_Pin_8);
}

//------------------End of File----------------------------
