/* UART2.c file

ܣ
UART1ͨ API
------------------------------------
 */

#include "UART2.h"

//uart reicer flag
#define b_uart_head  0x80
#define b_rx_over    0x40

// USART Receiver buffer
#define RX_BUFFER_SIZE 100

u8 U2TxBuffer[258];
u8 U2TxCounter=0;
u8 U2count=0; 

void U2NVIC_Configuration(void)
{
        NVIC_InitTypeDef NVIC_InitStructure; 
          /* Enable the USART1 Interrupt */
        NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
        NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
        NVIC_InitStructure.NVIC_IRQChannelSubPriority = 8;
        NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
        NVIC_Init(&NVIC_InitStructure);
}

/**************************ʵֺ********************************************
*ԭ:		void Initial_UART2(u32 baudrate)
*:		ʼSTM32-SDKϵRS232ӿ

		u32 baudrate   RS232ڵĲ
û	
*******************************************************************************/
void Initial_UART2(u32 baudrate)
{
 	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;

	/* ʹ UART2 ģʱ  ʹ UART2ӦŶ˿PAʱ*/
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2 | RCC_APB2Periph_GPIOA, ENABLE);

  	 /* UART2 ķ
	 PA9 Ϊ  ˢƵ50MHz
	  */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);    
  	/* 
	  UART2 Ľ
	  PA10Ϊ 
	 */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  	GPIO_Init(GPIOA, &GPIO_InitStructure);
	  
	/* 
	  UART2:
	  1.Ϊóָ baudrate;
	  2. 8λ			  USART_WordLength_8b;
	  3.һֹͣλ			  USART_StopBits_1;
	  4. żЧ			  USART_Parity_No ;
	  5.ʹӲ	  USART_HardwareFlowControl_None;
	  6.ʹܷͺͽչ	  USART_Mode_Rx | USART_Mode_Tx;
	 */
	USART_InitStructure.USART_BaudRate = baudrate;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	//ӦõUART2
	USART_Init(USART2, &USART_InitStructure); 
	USART_ITConfig(USART2, USART_IT_TXE, DISABLE);        
    USART_ClearFlag(USART2,USART_FLAG_TC);
	USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);	//ʹܽж
	//UART2
  	USART_Cmd(USART2, ENABLE);
	U2NVIC_Configuration();
}

/**************************ʵֺ********************************************
*ԭ:		void UART2_Put_Char(unsigned char DataToSend)
*:		RS232һֽ

		unsigned char DataToSend   Ҫ͵ֽ
û	
*******************************************************************************/
void UART2_Put_Char(unsigned char DataToSend)
{
	//Ҫ͵ֽдUART2ķͻ
	//USART_SendData(USART1, (unsigned char) DataToSend);
	//ȴ
  	//while (!(USART1->SR & USART_FLAG_TXE));

	U2TxBuffer[U2count++] = DataToSend;  
    USART_ITConfig(USART2, USART_IT_TXE, ENABLE);  
}

/**************************ʵֺ********************************************
*ԭ:		u8 UART2_Get_Char(void)
*:		RS232һֽ  һֱȴֱUART2յһֽڵݡ
		 û
       UART2յ	
*******************************************************************************/
u8 UART2_Get_Char(void)
{
	while (!(USART2->SR & USART_FLAG_RXNE));
	return(USART_ReceiveData(USART1));
}

/**************************ʵֺ********************************************
*ԭ:		void UART2_Put_String(unsigned char *Str)
*:		RS232ַ

		unsigned char *Str   Ҫ͵ַ
û	
*******************************************************************************/
void UART2_Put_String(unsigned char *Str)
{
	//жStrָǷЧ.
	while(*Str){
	//Ƿǻسַ ,ӦĻس 0x0d 0x0a
	if(*Str=='\r')UART2_Put_Char(0x0d);
		else if(*Str=='\n')UART2_Put_Char(0x0a);
			else UART2_Put_Char(*Str);
	//ȴ.
  	//while (!(USART1->SR & USART_FLAG_TXE));
	//ָ++ ָһֽ.
	Str++;
	}
/*
	//жStrָǷЧ.
	while(*Str){
	//Ƿǻسַ ,ӦĻس 0x0d 0x0a
	if(*Str=='\r')USART_SendData(USART1, 0x0d);
		else if(*Str=='\n')USART_SendData(USART1, 0x0a);
			else USART_SendData(USART1, *Str);
	//ȴ.
  	while (!(USART1->SR & USART_FLAG_TXE));
	//ָ++ ָһֽ.
	Str++;
	}		 */
}

/**************************ʵֺ********************************************
*ԭ:		void UART2_Putc_Hex(uint8_t b)
*:		RS232ʮASCIIķʽһֽ
				ȽĿֽݸ4λתASCCII ͣٽ4λתASCII
				:0xF2  " F2 "

		uint8_t b   Ҫ͵ֽ
û	
*******************************************************************************/
void UART2_Putc_Hex(uint8_t b)
{
      /* жĿֽڵĸ4λǷС10 */
    if((b >> 4) < 0x0a)
        UART2_Put_Char((b >> 4) + '0'); //С10  ,Ӧ0-9ASCII
    else
        UART2_Put_Char((b >> 4) - 0x0a + 'A'); //ڵ10 Ӧ A-F

    /* жĿֽڵĵ4λ ǷС10*/
    if((b & 0x0f) < 0x0a)
        UART2_Put_Char((b & 0x0f) + '0');//С10  ,Ӧ0-9ASCII
    else
        UART2_Put_Char((b & 0x0f) - 0x0a + 'A');//ڵ10 Ӧ A-F
   UART2_Put_Char(' '); //һո,ֽֿ
}

/**************************ʵֺ********************************************
*ԭ:		void UART2_Putw_Hex(uint16_t w)
*:		RS232ʮASCIIķʽһֵ.Ƿһint
				:0x3456  " 3456 "

		uint16_t w   Ҫ͵
û	
*******************************************************************************/
void UART2_Putw_Hex(uint16_t w)
{
	//͸8λ,һֽڷ
    UART2_Putc_Hex((uint8_t) (w >> 8));
	//͵8λ,һֽڷ
    UART2_Putc_Hex((uint8_t) (w & 0xff));
}

/**************************ʵֺ********************************************
*ԭ:		void UART2_Putdw_Hex(uint32_t dw)
*:		RS232ʮASCIIķʽ32λ.
				:0xF0123456  " F0123456 "

		uint32_t dw   Ҫ͵32λֵ
û	
*******************************************************************************/
void UART2_Putdw_Hex(uint32_t dw)
{
    UART2_Putw_Hex((uint16_t) (dw >> 16));
    UART2_Putw_Hex((uint16_t) (dw & 0xffff));
}

/**************************ʵֺ********************************************
*ԭ:		void UART2_Putw_Dec(uint16_t w)
*:		RS232ʮASCIIķʽ16λ.
				:0x123 ʮ " 291 "

		uint16_t w   Ҫ͵16λֵ
û	
*******************************************************************************/
void UART2_Putw_Dec(uint32_t w)
{
    uint32_t num = 100000;
    uint8_t started = 0;

    while(num > 0)
    {
        uint8_t b = w / num;
        if(b > 0 || started || num == 1)
        {
            UART2_Put_Char('0' + b);
            started = 1;
        }
        w -= b * num;

        num /= 10;
    }
}

void UART2_Putint_Dec(int16_t in)
{
	if(in<0){
	in=-in;
	UART2_Put_Char('-');
	}
   UART2_Putw_Dec(in);
}

void UART2_Putintp_Dec(int16_t in)
{
	if(in<0){
	in=-in;
	UART2_Put_Char('-');
	}
   UART2_Putw_Dec(in/10);
   UART2_Put_Char('.');
   UART2_Putw_Dec(in%10);
}


void UART2_ReportIMU(int16_t yaw,int16_t pitch,int16_t roll
,int16_t alt,int16_t tempr,int16_t press,int16_t IMUpersec)
{
 	unsigned int temp=0xaF+2+2;
	char ctemp;
	UART2_Put_Char(0xa5);
	UART2_Put_Char(0x5a);
	UART2_Put_Char(14+4);
	UART2_Put_Char(0xA1);

	if(yaw<0)yaw=32768-yaw;
	ctemp=yaw>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=yaw;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(pitch<0)pitch=32768-pitch;
	ctemp=pitch>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=pitch;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(roll<0)roll=32768-roll;
	ctemp=roll>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=roll;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(alt<0)alt=32768-alt;
	ctemp=alt>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=alt;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(tempr<0)tempr=32768-tempr;
	ctemp=tempr>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=tempr;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(press<0)press=32768-press;
	ctemp=press>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=press;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	ctemp=IMUpersec>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=IMUpersec;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	UART2_Put_Char(temp%256);
	UART2_Put_Char(0xaa);
}

void UART2_ReportMotion(int16_t ax,int16_t ay,int16_t az,int16_t gx,int16_t gy,int16_t gz,
					int16_t hx,int16_t hy,int16_t hz)
{
 	unsigned int temp=0xaF+9;
	char ctemp;
	UART2_Put_Char(0xa5);
	UART2_Put_Char(0x5a);
	UART2_Put_Char(14+8);
	UART2_Put_Char(0xA2);

	if(ax<0)ax=32768-ax;
	ctemp=ax>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=ax;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(ay<0)ay=32768-ay;
	ctemp=ay>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=ay;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(az<0)az=32768-az;
	ctemp=az>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=az;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(gx<0)gx=32768-gx;
	ctemp=gx>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=gx;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(gy<0)gy=32768-gy;
	ctemp=gy>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=gy;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
//-------------------------
	if(gz<0)gz=32768-gz;
	ctemp=gz>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=gz;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(hx<0)hx=32768-hx;
	ctemp=hx>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=hx;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(hy<0)hy=32768-hy;
	ctemp=hy>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=hy;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(hz<0)hz=32768-hz;
	ctemp=hz>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=hz;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	UART2_Put_Char(temp%256);
	UART2_Put_Char(0xaa);
}

void UART2_ReportHMC(int16_t maxx,int16_t maxy,int16_t maxz
,int16_t minx,int16_t miny,int16_t minz,int16_t IMUpersec)
{
 	unsigned int temp=0xaF+2+2+3;
	char ctemp;
	UART2_Put_Char(0xa5);
	UART2_Put_Char(0x5a);
	UART2_Put_Char(14+4);
	UART2_Put_Char(0xA4);

	if(maxx<0)maxx=32768-maxx;
	ctemp=maxx>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=maxx;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(maxy<0)maxy=32768-maxy;
	ctemp=maxy>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=maxy;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(maxz<0)maxz=32768-maxz;
	ctemp=maxz>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=maxz;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(minx<0)minx=32768-minx;
	ctemp=minx>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=minx;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(miny<0)miny=32768-miny;
	ctemp=miny>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=miny;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	if(minz<0)minz=32768-minz;
	ctemp=minz>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=minz;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	ctemp=IMUpersec>>8;
	UART2_Put_Char(ctemp);
	temp+=ctemp;
	ctemp=IMUpersec;
	UART2_Put_Char(ctemp);
	temp+=ctemp;

	UART2_Put_Char(temp%256);
	UART2_Put_Char(0xaa);
}



volatile unsigned char rx_buffer[RX_BUFFER_SIZE];
volatile unsigned char rx_wr_index;
volatile unsigned char RC_Flag;
//------------------------------------------------------
void USART2_IRQHandler(void)
{
  unsigned char data;
  if(USART_GetITStatus(USART2, USART_IT_TXE) != RESET)
  {   
    /* Write one byte to the transmit data register */
    USART_SendData(USART2, U2TxBuffer[U2TxCounter++]);                    

    /* Clear the USART1 transmit interrupt */
    USART_ClearITPendingBit(USART2, USART_IT_TXE); 

    if(U2TxCounter == U2count)
    {
      /* Disable the USART1 Transmit interrupt */
      USART_ITConfig(USART2, USART_IT_TXE, DISABLE);
    }    
  }else if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)
  {
  data=USART_ReceiveData(USART2);
  if(data==0xa5)
  { 
	RC_Flag|=b_uart_head;
    rx_buffer[rx_wr_index++]=data;
  }
  else if(data==0x5a)
       { if(RC_Flag&b_uart_head)
	     { rx_wr_index=0;
		   RC_Flag&=~b_rx_over;
         }
         else
		  rx_buffer[rx_wr_index++]=data;
         RC_Flag&=~b_uart_head;
       }
	   else
	   { rx_buffer[rx_wr_index++]=data;
		 RC_Flag&=~b_uart_head;
		 if(rx_wr_index==rx_buffer[0])
	     {  
			RC_Flag|=b_rx_over;
          }
	   }
  if(rx_wr_index==RX_BUFFER_SIZE)
  rx_wr_index--;
  /* Clear the USART1 transmit interrupt */
  USART_ClearITPendingBit(USART2, USART_IT_RXNE);
  }
}

/*
+------------------------------------------------------------------------------
| Function    : Sum_check(void)
+------------------------------------------------------------------------------
| Description : check
|
| Parameters  : 
| Returns     : 
|
+------------------------------------------------------------------------------
*/
unsigned char Sum_check(void)
{ 
  unsigned char i;
  unsigned int checksum=0; 
  for(i=0;i<rx_buffer[0]-2;i++)
   checksum+=rx_buffer[i];
  if((checksum%256)==rx_buffer[rx_buffer[0]-2])
   return(0x01); //Checksum successful
  else
   return(0x00); //Checksum error
}

unsigned char UART2_CommandRoute(void)
{
 if(RC_Flag&b_rx_over){
		RC_Flag&=~b_rx_over;
		if(Sum_check()){
		return rx_buffer[1];
		}
	}
return 0xff; //ûյλЧûͨ
}


//------------------End of File----------------------------
